## fio 0.1.0

=== DESCRIPTION ===
Package: fio
Title: Friendly Input-Output Analysis
Version: 0.1.0
Authors@R: c(
  person(
    given = "Alberson",
    family = "da Silva Miranda",
    email = "albersonmiranda@hotmail.com",
    role = c("aut", "cre", "cph"),
    comment = c(ORCID = "0000-0001-9252-4175")
    ),
  person(
    given = "Celso",
    family = "Bissoli Sessa",
    email = "celso.sessa@ufes.br",
    role = c("dtc"),
    comment = c(ORCID = "0000-0001-7616-0244")
    )
  )
Description: Simplifies the process of importing and managing input-output
  matrices from 'Microsoft Excel' into R, and provides a suite of functions for
  analysis. It leverages the 'R6' class for clean, memory-efficient
  object-oriented programming. Furthermore, all linear algebra computations are
  implemented in 'Rust' to achieve highly optimized performance.
URL: https://albersonmiranda.github.io/fio/,
        https://github.com/albersonmiranda/fio
BugReports: https://github.com/albersonmiranda/fio/issues
Encoding: UTF-8
RoxygenNote: 7.3.2
Depends: R (>= 4.0)
SystemRequirements: Cargo (Rust's package manager), rustc (Rust's
        compiler)
LazyData: true
Imports: cli, clipr, emoji, fs, miniUI, readxl, rlang, shiny, Rdpack
License: MIT + file LICENSE
Config/rextendr/version: 0.3.1
Suggests: knitr, rmarkdown, spelling, microbenchmark, leontief,
        ggplot2, writexl, callr, testthat (>= 3.0.0)
VignetteBuilder: knitr
Language: en-US
Config/testthat/edition: 3
RdMacros: Rdpack
NeedsCompilation: yes
Packaged: 2024-07-30 15:54:41 UTC; albersonmiranda
Author: Alberson da Silva Miranda [aut, cre, cph]
    (<https://orcid.org/0000-0001-9252-4175>),
  Celso Bissoli Sessa [dtc] (<https://orcid.org/0000-0001-7616-0244>)
Maintainer: Alberson da Silva Miranda <albersonmiranda@hotmail.com>
Repository: CRAN
Date/Publication: 2024-08-01 14:40:05 UTC

## fio 0.1.1

=== DESCRIPTION ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Package: fio
 Title: Friendly Input-Output Analysis
-Version: 0.1.0
+Version: 0.1.1
 Authors@R: c(
   person(
     given = "Alberson",
@@ -28,12 +28,12 @@
 Encoding: UTF-8
 RoxygenNote: 7.3.2
 Depends: R (>= 4.0)
-SystemRequirements: Cargo (Rust's package manager), rustc (Rust's
-        compiler)
+SystemRequirements: Cargo (Rust's package manager), rustc >= 1.67.1, xz
 LazyData: true
-Imports: cli, clipr, emoji, fs, miniUI, readxl, rlang, shiny, Rdpack
+Imports: cli, clipr, emoji, fs, miniUI, readxl, rlang, shiny, Rdpack,
+        R6
 License: MIT + file LICENSE
-Config/rextendr/version: 0.3.1
+Config/rextendr/version: 0.3.1.9000
 Suggests: knitr, rmarkdown, spelling, microbenchmark, leontief,
         ggplot2, writexl, callr, testthat (>= 3.0.0)
 VignetteBuilder: knitr
@@ -41,10 +41,10 @@
 Config/testthat/edition: 3
 RdMacros: Rdpack
 NeedsCompilation: yes
-Packaged: 2024-07-30 15:54:41 UTC; albersonmiranda
+Packaged: 2024-08-16 10:17:34 UTC; albersonmiranda
 Author: Alberson da Silva Miranda [aut, cre, cph]
     (<https://orcid.org/0000-0001-9252-4175>),
   Celso Bissoli Sessa [dtc] (<https://orcid.org/0000-0001-7616-0244>)
 Maintainer: Alberson da Silva Miranda <albersonmiranda@hotmail.com>
 Repository: CRAN
-Date/Publication: 2024-08-01 14:40:05 UTC
+Date/Publication: 2024-08-21 12:40:02 UTC

## fio 0.1.2

=== DESCRIPTION ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Package: fio
 Title: Friendly Input-Output Analysis
-Version: 0.1.1
+Version: 0.1.2
 Authors@R: c(
   person(
     given = "Alberson",
@@ -41,10 +41,10 @@
 Config/testthat/edition: 3
 RdMacros: Rdpack
 NeedsCompilation: yes
-Packaged: 2024-08-16 10:17:34 UTC; albersonmiranda
+Packaged: 2024-08-26 03:56:16 UTC; albersonmiranda
 Author: Alberson da Silva Miranda [aut, cre, cph]
     (<https://orcid.org/0000-0001-9252-4175>),
   Celso Bissoli Sessa [dtc] (<https://orcid.org/0000-0001-7616-0244>)
 Maintainer: Alberson da Silva Miranda <albersonmiranda@hotmail.com>
 Repository: CRAN
-Date/Publication: 2024-08-21 12:40:02 UTC
+Date/Publication: 2024-08-27 08:10:06 UTC

## fio 0.1.5

=== DESCRIPTION ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Package: fio
 Title: Friendly Input-Output Analysis
-Version: 0.1.2
+Version: 0.1.5
 Authors@R: c(
   person(
     given = "Alberson",
@@ -27,13 +27,13 @@
 BugReports: https://github.com/albersonmiranda/fio/issues
 Encoding: UTF-8
 RoxygenNote: 7.3.2
-Depends: R (>= 4.0)
+Depends: R (>= 4.2)
 SystemRequirements: Cargo (Rust's package manager), rustc >= 1.67.1, xz
 LazyData: true
-Imports: cli, clipr, emoji, fs, miniUI, readxl, rlang, shiny, Rdpack,
-        R6
+Imports: cli, clipr, emoji, fs, miniUI, readxl, rlang, shiny, Rdpack (>
+        2.3.1), R6
 License: MIT + file LICENSE
-Config/rextendr/version: 0.3.1.9000
+Config/rextendr/version: 0.3.1.9001
 Suggests: knitr, rmarkdown, spelling, microbenchmark, leontief,
         ggplot2, writexl, callr, testthat (>= 3.0.0)
 VignetteBuilder: knitr
@@ -41,10 +41,10 @@
 Config/testthat/edition: 3
 RdMacros: Rdpack
 NeedsCompilation: yes
-Packaged: 2024-08-26 03:56:16 UTC; albersonmiranda
+Packaged: 2025-04-02 19:47:55 UTC; albersonmiranda
 Author: Alberson da Silva Miranda [aut, cre, cph]
     (<https://orcid.org/0000-0001-9252-4175>),
   Celso Bissoli Sessa [dtc] (<https://orcid.org/0000-0001-7616-0244>)
 Maintainer: Alberson da Silva Miranda <albersonmiranda@hotmail.com>
 Repository: CRAN
-Date/Publication: 2024-08-27 08:10:06 UTC
+Date/Publication: 2025-04-02 21:50:09 UTC

## fio 0.1.6

=== DESCRIPTION ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Package: fio
 Title: Friendly Input-Output Analysis
-Version: 0.1.5
+Version: 0.1.6
 Authors@R: c(
   person(
     given = "Alberson",
@@ -28,7 +28,7 @@
 Encoding: UTF-8
 RoxygenNote: 7.3.2
 Depends: R (>= 4.2)
-SystemRequirements: Cargo (Rust's package manager), rustc >= 1.67.1, xz
+SystemRequirements: Cargo (Rust's package manager), rustc >= 1.77, xz
 LazyData: true
 Imports: cli, clipr, emoji, fs, miniUI, readxl, rlang, shiny, Rdpack (>
         2.3.1), R6
@@ -41,10 +41,10 @@
 Config/testthat/edition: 3
 RdMacros: Rdpack
 NeedsCompilation: yes
-Packaged: 2025-04-02 19:47:55 UTC; albersonmiranda
+Packaged: 2025-04-05 13:50:51 UTC; albersonmiranda
 Author: Alberson da Silva Miranda [aut, cre, cph]
     (<https://orcid.org/0000-0001-9252-4175>),
   Celso Bissoli Sessa [dtc] (<https://orcid.org/0000-0001-7616-0244>)
 Maintainer: Alberson da Silva Miranda <albersonmiranda@hotmail.com>
 Repository: CRAN
-Date/Publication: 2025-04-02 21:50:09 UTC
+Date/Publication: 2025-04-06 07:50:02 UTC

## fio 1.0.0

=== DESCRIPTION ===
Package: fio
Title: Friendly Input-Output Analysis
Version: 1.0.0
Authors@R: c(
  person(
    given = "Alberson",
    family = "da Silva Miranda",
    email = "albersonmiranda@hotmail.com",
    role = c("aut", "cre", "cph"),
    comment = c(ORCID = "0000-0001-9252-4175")
    ),
  person(
    given = "Celso",
    family = "Bissoli Sessa",
    email = "celso.sessa@ufes.br",
    role = c("dtc"),
    comment = c(ORCID = "0000-0001-7616-0244")
    )
  )
Description: Simplifies the process of economic input-output analysis by combining
  user-friendly interfaces with high-performance computation. It provides tools
  for analyzing both single-region and multi-regional economic systems through a
  hybrid architecture that pairs R's accessibility with Rust's computational efficiency.
URL: https://albersonmiranda.github.io/fio/,
        https://github.com/albersonmiranda/fio
BugReports: https://github.com/albersonmiranda/fio/issues
Encoding: UTF-8
RoxygenNote: 7.3.3
Depends: R (>= 4.2)
SystemRequirements: Cargo (Rust's package manager), rustc >= 1.84, xz
Imports: cli, clipr, emoji, fs, miniUI, readxl, rlang, shiny, Rdpack (>
        2.3.1), R6
License: MIT + file LICENSE
Config/rextendr/version: 0.4.2.9000
Suggests: knitr, rmarkdown, spelling, bench, leontief, ggplot2,
        writexl, callr, testthat (>= 3.0.0), fiodata
VignetteBuilder: knitr
Language: en-US
Config/testthat/edition: 3
RdMacros: Rdpack
NeedsCompilation: yes
Packaged: 2026-02-26 15:10:30 UTC; albersonmiranda
Author: Alberson da Silva Miranda [aut, cre, cph] (ORCID:
    <https://orcid.org/0000-0001-9252-4175>),
  Celso Bissoli Sessa [dtc] (ORCID:
    <https://orcid.org/0000-0001-7616-0244>)
Maintainer: Alberson da Silva Miranda <albersonmiranda@hotmail.com>
Repository: CRAN
Date/Publication: 2026-02-27 08:40:02 UTC

## fio 1.33.1

=== Makefile ===
CC	= gcc
DEBUGFLAGS = -D_FORTIFY_SOURCE=2 -DFIO_INC_DEBUG
OPTFLAGS= -O2 -g $(EXTFLAGS)
CFLAGS	= -Wwrite-strings -Wall -D_GNU_SOURCE -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64 $(OPTFLAGS) $(DEBUGFLAGS) -fno-omit-frame-pointer -rdynamic
PROGS	= fio
SCRIPTS = fio_generate_plots
OBJS = gettime.o fio.o ioengines.o init.o stat.o log.o time.o filesetup.o \
	eta.o verify.o memory.o io_u.o parse.o mutex.o options.o \
	rbtree.o diskutil.o fifo.o blktrace.o smalloc.o filehash.o

OBJS += crc/crc7.o
OBJS += crc/crc16.o
OBJS += crc/crc32.o
OBJS += crc/crc32c.o
OBJS += crc/crc32c-intel.o
OBJS += crc/crc64.o
OBJS += crc/sha1.o
OBJS += crc/sha256.o
OBJS += crc/sha512.o
OBJS += crc/md5.o

OBJS += engines/cpu.o
OBJS += engines/libaio.o
OBJS += engines/mmap.o
OBJS += engines/posixaio.o
OBJS += engines/sg.o
OBJS += engines/splice.o
OBJS += engines/sync.o
OBJS += engines/null.o
OBJS += engines/net.o
OBJS += engines/syslet-rw.o
OBJS += engines/guasi.o

ifneq ($(findstring $(MAKEFLAGS),s),s)
ifndef V
	QUIET_CC	= @echo '   ' CC $@;
	QUIET_DEP	= @echo '   ' DEP $@;
endif
endif

INSTALL = install
prefix = /usr/local
bindir = $(prefix)/bin
mandir = $(prefix)/man

%.o: %.c
	$(QUIET_CC)$(CC) -o $*.o -c $(CFLAGS) $<
fio: $(OBJS)
	$(QUIET_CC)$(CC) $(CFLAGS) -o $@ $(filter %.o,$^) $(EXTLIBS) -lpthread -lm -ldl -laio -lrt

depend:
	$(QUIET_DEP)$(CC) -MM $(ALL_CFLAGS) *.c engines/*.c crc/*.c 1> .depend

$(PROGS): depend

all: depend $(PROGS) $(SCRIPTS)

clean:
	-rm -f .depend cscope.out $(OBJS) $(PROGS) core.* core

cscope:
	@cscope -b

install: $(PROGS) $(SCRIPTS)
	$(INSTALL) -m755 -d $(DESTDIR)$(bindir)
	$(INSTALL) $(PROGS) $(SCRIPTS) $(DESTDIR)$(bindir)
	$(INSTALL) -m 755 -d $(DESTDIR)$(mandir)/man1
	$(INSTALL) -m 644 fio.1 $(DESTDIR)$(mandir)/man1
	$(INSTALL) -m 644 fio_generate_plots.1 $(DESTDIR)$(mandir)/man1

ifneq ($(wildcard .depend),)
include .depend
endif

## fio 1.38

=== Makefile ===
--- 
+++ 
@@ -6,7 +6,8 @@
 SCRIPTS = fio_generate_plots
 OBJS = gettime.o fio.o ioengines.o init.o stat.o log.o time.o filesetup.o \
 	eta.o verify.o memory.o io_u.o parse.o mutex.o options.o \
-	rbtree.o diskutil.o fifo.o blktrace.o smalloc.o filehash.o
+	rbtree.o diskutil.o fifo.o blktrace.o smalloc.o filehash.o helpers.o \
+	cgroup.o profile.o debug.o
 
 OBJS += crc/crc7.o
 OBJS += crc/crc16.o
@@ -30,6 +31,8 @@
 OBJS += engines/net.o
 OBJS += engines/syslet-rw.o
 OBJS += engines/guasi.o
+
+OBJS += profiles/tiobench.o
 
 ifneq ($(findstring $(MAKEFLAGS),s),s)
 ifndef V

=== debian/changelog ===
fio (1.38-1) unstable; urgency=low

  * New Upstream Version:
    * Should build on ARMv7 now, thanks Jamie Bennett (Closes: #573027).

 -- Martin Steigerwald <ms@teamix.de>  Wed, 14 Apr 2010 18:23:14 +0200

fio (1.36-1) unstable; urgency=low

  * New upstream version.
  * Doesn't build on sh4 / sh4a / sh5 at the moment. Fix is being
    worked on: See debian bug #561891.
  * Updated Standards-Version to 3.8.4, no changes.
  * Updated source format to 3.0 (quilt), no changes.

 -- Martin Steigerwald <ms@teamix.de>  Mon, 15 Feb 2010 15:17:22 +0100

fio (1.33.1-2) UNRELEASED; urgency=low

  * Moved over repository to Alioth/CollabMaint.
  * debian/control: Updated Vcs-Git and Vcs-Browser.
  * Added debian/gbp.conf with option to always use pristine-tar.
  * debian/gbp.conf: Added option to call git-dch after import.
    Since git-buildpackage 0.4.57 git-import-orig doesn't add a
    changelog entry manually anymore.
  * Added forgotten pristine-tar delta for fio 1.33.1.
  * Added tags that I forgot to push. Thanks to Bruno Kleinert for help.

 -- Martin Steigerwald <ms@teamix.de>  Thu, 17 Sep 2009 11:07:00 +0200

fio (1.33.1-1) unstable; urgency=low

  * arch/arch-alpha.h: Removed my FTBFS on alpha bugfix. Applied upstream.
  * New Upstream Version. (Closes: #545839).
  * control: Added Vcs-Git and Vcs-Browser.
  * Updated Standards-Version to 3.8.3.

 -- Martin Steigerwald <ms@teamix.de>  Thu, 10 Sep 2009 11:37:00 +0200

fio (1.32-2) UNRELEASED; urgency=low

  * arch/arch-alpha.h: Correct typo writer_barrier to write_barrier.
    Thanks, Kurt Roeckx. (Closes: #545839).

 -- Martin Steigerwald <ms@teamix.de>  Thu, 10 Sep 2009 09:30:07 +0200

fio (1.32-1) unstable; urgency=low

  [ Martin Steigerwald ]
  * New upstream release.
  * Dropped patch for lintian error in original manpage, fixed
    upstream.
  * Dropped manpage for bash shell script fio_generate_plots,
    upstream integrated it.
  * Imported to git-buildpackage with pristine tar.
  * Included examples as documentation.
  * Fixed watch file to ignore git-latest snapshots.

  [ Michael Prokop ]
  * fio.1: fix hyphen-used-as-minus-sign
  * debian/copyright: refer to gpl2 and include its header;
    updated URLs; some formating changes
  * debian/rules: drop unnecessary configure target;
    replace dh_clean with dh_prep; drop templates
  * Bump Standard-Version to 3.8.2; add myself to Uploaders

  [ Martin Steigerwald ]
  * debian/copyright: fix copyright unicode char and replaced
    another (C) with it, thanks Michael.

 -- Martin Steigerwald <ms@teamix.de>  Thu, 13 Aug 2009 08:22:40 +0200

fio (1.26-1) UNRELEASED; urgency=low

  * Initial release (Closes: #524790).
  * Changed Makefile to build to /usr instead of /usr/local.
  * Changed Makefile to install the manpage /usr/share/man.
  * Fixed a lintian reported error in the original manpage.
  * Created manpage for bash shell script fio_generate_plots.

 -- Martin Steigerwald <ms@teamix.de>  Tue, 19 May 2009 17:12:02 +0200

=== debian/control ===
Source: fio
Section: utils
Priority: optional
Maintainer: Martin Steigerwald <ms@teamix.de>
Uploaders: Michael Prokop <mika@debian.org>
Build-Depends: debhelper (>= 7), libaio-dev
Standards-Version: 3.8.4
Homepage: http://freshmeat.net/projects/fio
Vcs-Git: git://git.debian.org/git/collab-maint/fio.git
Vcs-Browser: http://git.debian.org/git/collab-maint/fio.git

Package: fio
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: gnuplot
Description: Flexible I/O Tester
 fio is a tool that will spawn a number of threads or processes doing a
 particular type of io action as specified by the user. fio takes a
 number of global parameters, each inherited by the thread unless
 otherwise parameters given to them overriding that setting is given.
 The typical use of fio is to write a job file matching the io load
 one wants to simulate.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

build: build-stamp

build-stamp:
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE)

	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp

	# Add here commands to clean up after the build process.
	$(MAKE) clean

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	# Add here commands to install the package into debian/fio.
	$(MAKE) DESTDIR=$(CURDIR)/debian/fio install


# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installdocs
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

=== debian/watch ===
# Example watch control file for uscan
# Rename this file to "watch" and then you can run the "uscan" command
# to check for upstream updates and more.
# See uscan(1) for format

# Compulsory line, this is a version 3 file
version=3

# Uncomment to examine a Webserver directory
http://brick.kernel.dk/snaps/fio-\d(.*)\.tar\.gz

## fio 1.57

=== Makefile ===
CC	= gcc
DEBUGFLAGS = -D_FORTIFY_SOURCE=2 -DFIO_INC_DEBUG
CPPFLAGS= -D_GNU_SOURCE -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64 \
	$(DEBUGFLAGS)
OPTFLAGS= -O2 -fno-omit-frame-pointer -g $(EXTFLAGS)
CFLAGS	= -std=gnu99 -Wwrite-strings -Wall $(OPTFLAGS)
LIBS	= -lm
PROGS	= fio
SCRIPTS = fio_generate_plots
UNAME  := $(shell uname)

SOURCE = gettime.c fio.c ioengines.c init.c stat.c log.c time.c filesetup.c \
		eta.c verify.c memory.c io_u.c parse.c mutex.c options.c \
		rbtree.c smalloc.c filehash.c profile.c debug.c lib/rand.c \
		lib/num2str.c $(wildcard crc/*.c) engines/cpu.c \
		engines/mmap.c engines/sync.c engines/null.c engines/net.c \
		memalign.c

ifeq ($(UNAME), Linux)
  SOURCE += diskutil.c fifo.c blktrace.c helpers.c cgroup.c trim.c \
		engines/libaio.c engines/posixaio.c engines/sg.c \
		engines/splice.c engines/syslet-rw.c engines/guasi.c \
		engines/binject.c profiles/tiobench.c
  LIBS += -lpthread -ldl -lrt -laio
  CFLAGS += -rdynamic
endif
ifeq ($(UNAME), SunOS)
  SOURCE += fifo.c lib/strsep.c helpers.c engines/posixaio.c \
		engines/solarisaio.c
  LIBS	 += -lpthread -ldl -laio -lrt -lnsl -lsocket
  CPPFLAGS += -D__EXTENSIONS__
endif
ifeq ($(UNAME), FreeBSD)
  SOURCE += helpers.c engines/posixaio.c
  LIBS	 += -lpthread -lrt
  CFLAGS += -rdynamic
endif
ifeq ($(UNAME), NetBSD)
  SOURCE += helpers.c engines/posixaio.c
  LIBS	 += -lpthread -lrt
  CFLAGS += -rdynamic
endif
ifeq ($(UNAME), AIX)
  SOURCE += fifo.c helpers.c lib/getopt_long.c engines/posixaio.c
  LIBS	 += -lpthread -ldl -lrt
  CPPFLAGS += -D_LARGE_FILES -D__ppc__
  LDFLAGS += -L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000
endif
ifeq ($(UNAME), HP-UX)
  SOURCE += fifo.c helpers.c lib/getopt_long.c lib/strsep.c engines/posixaio.c
  LIBS   += -lpthread -ldl -lrt
  CFLAGS += -D_LARGEFILE64_SOURCE
endif
ifeq ($(UNAME), Darwin)
  SOURCE += helpers.c engines/posixaio.c
  LIBS	 += -lpthread -ldl
endif
ifneq (,$(findstring CYGWIN,$(UNAME)))
  SOURCE += engines/windowsaio.c
  LIBS	 += -lpthread -lrt -lpsapi
  CFLAGS += -DPSAPI_VERSION=1
endif

OBJS = $(SOURCE:.c=.o)

ifneq ($(findstring $(MAKEFLAGS),s),s)
ifndef V
	QUIET_CC	= @echo '   ' CC $@;
	QUIET_DEP	= @echo '   ' DEP $@;
endif
endif

INSTALL = install
prefix = /usr/local
bindir = $(prefix)/bin
mandir = $(prefix)/man

all: .depend $(PROGS) $(SCRIPTS)

.c.o: .depend
	$(QUIET_CC)$(CC) -o $@ -c $(CFLAGS) $(CPPFLAGS) $<

fio: $(OBJS)
	$(QUIET_CC)$(CC) $(LDFLAGS) $(CFLAGS) -o $@ $(OBJS) $(LIBS) $(LDFLAGS)

.depend: $(SOURCE)
	$(QUIET_DEP)$(CC) -MM $(CFLAGS) $(CPPFLAGS) $(SOURCE) 1> .depend

$(PROGS): .depend

clean:
	-rm -f .depend $(OBJS) $(PROGS) core.* core

cscope:
	@cscope -b -R

install: $(PROGS) $(SCRIPTS)
	$(INSTALL) -m 755 -d $(DESTDIR)$(bindir)
	$(INSTALL) $(PROGS) $(SCRIPTS) $(DESTDIR)$(bindir)
	$(INSTALL) -m 755 -d $(DESTDIR)$(mandir)/man1
	$(INSTALL) -m 644 fio.1 $(DESTDIR)$(mandir)/man1
	$(INSTALL) -m 644 fio_generate_plots.1 $(DESTDIR)$(mandir)/man1

ifneq ($(wildcard .depend),)
include .depend
endif

=== debian/changelog ===
fio (1.57-1) unstable; urgency=low

  * Imported Upstream version 1.57.
  * Dropped manpage patch with manpage spelling fixes. Merged upstream.
  * Implemented suggestions from Sebastian 'Tokkee' Harl. Thanks.
    * Added -a to debhelper commands in architecture dependent sections
      of the makefile.
    * debian/copyright: Added authors of manpages for fio and
      fio_generate_plots.
    * debian/copyright: Added copyright hints for sha1.c, sha.h,
      engines/windowsaio.c, lib/getopt_long.c, lib/rand.c.

 -- Martin Steigerwald <ms@teamix.de>  Wed, 03 Aug 2011 14:05:33 +0200

fio (1.55-1) UNRELEASED; urgency=low

  * Corrected debian/watch file, thanks Ilya Barygin (Closes: #629174).
  * Imported Upstream version 1.55.
    * Includes commit e52947d15cf0d7d31c30ccdc43450a10081976da
      that fixes build failure with --as-needed linker option
      (Closes: #631690).
  * Updated to Standards-Version to 3.9.2, no changes needed.
  * debian/watch: Removed template to fix lintian warning
    debian-watch-contains-dh_make-template.
  * debian/rules: Added build-arch and build-indep as targets as
    recommended by lintian 2.5.1 in order to prepare for a future
    policy change.
    * build-indep does nothing as there are no architecture
      independent packages for now.

 -- Martin Steigerwald <ms@teamix.de>  Mon, 27 Jun 2011 14:32:05 +0200

fio (1.50-1) unstable; urgency=low

  * Thanks for importing, Ritesh. Found my mistake with
    help of Sebastian Harl. Thanks.
  * New upstream version 1.5.0 (Closes: #613432).
  * Updated to Standards-Version to 3.9.1, no changes needed.
  * Patch to fix spelling errors in manpage. Forwarded upstream.
  * Updated upstream copyright.

 -- Martin Steigerwald <ms@teamix.de>  Wed, 16 Feb 2011 11:57:56 +0100

fio (1.50-1~1.gbpa4517a) UNRELEASED; urgency=low

  * Imported Upstream version 1.50.

 -- Ritesh Raj Sarraf <rrs@debian.org>  Tue, 15 Feb 2011 19:19:14 +0530

=== debian/control ===
Source: fio
Section: utils
Priority: optional
Maintainer: Martin Steigerwald <ms@teamix.de>
Uploaders: Michael Prokop <mika@debian.org>
Build-Depends: debhelper (>= 7), libaio-dev
Standards-Version: 3.9.2
Homepage: http://freshmeat.net/projects/fio
Vcs-Git: git://git.debian.org/git/collab-maint/fio.git
Vcs-Browser: http://git.debian.org/git/collab-maint/fio.git

Package: fio
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: gnuplot
Description: Flexible I/O Tester
 fio is a tool that will spawn a number of threads or processes doing a
 particular type of I/O action as specified by the user. fio takes a
 number of global parameters, each inherited by the thread unless
 otherwise parameters given to them overriding that setting is given.
 The typical use of fio is to write a job file matching the I/O load
 one wants to simulate.

=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,13 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
-build: build-stamp
+build: build-arch build-indep
+
+build-arch: build-stamp
+
+build-indep:
+# Since there are no architecture independent packages we
+# have nothing to build by default.
 
 build-stamp:
 	dh_testdir
@@ -29,36 +35,42 @@
 
 	dh_clean
 
-install: build
-	dh_testdir
-	dh_testroot
-	dh_prep
-	dh_installdirs
+install-indep:
+# Since there are no architecture independent packages we have
+# nothing to install by default.
+
+install-arch: build-arch
+	dh_testdir -a
+	dh_testroot -a
+	dh_prep -a
+	dh_installdirs -a
 
 	# Add here commands to install the package into debian/fio.
 	$(MAKE) DESTDIR=$(CURDIR)/debian/fio install
 
+install: install-arch install-indep
 
 # Build architecture-independent files here.
-binary-indep: build install
-# We have nothing to do by default.
+binary-indep: build-indep install-indep
+# Since there are no architecture independent packages We have
+# nothing to do by default.
 
 # Build architecture-dependent files here.
-binary-arch: build install
-	dh_testdir
-	dh_testroot
-	dh_installchangelogs
-	dh_installdocs
-	dh_installman
-	dh_link
-	dh_strip
-	dh_compress
-	dh_fixperms
-	dh_installdeb
-	dh_shlibdeps
-	dh_gencontrol
-	dh_md5sums
-	dh_builddeb
+binary-arch: build-arch install-arch
+	dh_testdir -a
+	dh_testroot -a
+	dh_installchangelogs -a
+	dh_installdocs -a
+	dh_installman -a
+	dh_link -a
+	dh_strip -a
+	dh_compress -a
+	dh_fixperms -a
+	dh_installdeb -a
+	dh_shlibdeps -a
+	dh_gencontrol -a
+	dh_md5sums -a
+	dh_builddeb -a
 
 binary: binary-indep binary-arch
 .PHONY: build clean binary-indep binary-arch binary install

## fio 1.59

=== debian/changelog ===
fio (1.59-1) unstable; urgency=low

  * Imported Upstream version 1.59.
    - Added support for SuperH architecture (Closes: #561891).
      Thanks to Nobuhiro Iwamatsu for the patch and build testing.
  * debian/patches/manpage: Escape minus signs to fix lintian warning
    I: fio: hyphen-used-as-minus-sign usr/share/man/man1/fio.1.gz:934
  * New rdma engine in engines/rdma.c:
    * debian/rules: Add variables for makefile to build new rdma engine.
    * debian/control: Added build dependencies for new rdma engine.

 -- Martin Steigerwald <ms@teamix.de>  Wed, 10 Oct 2011 17:19:00 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Martin Steigerwald <ms@teamix.de>
 Uploaders: Michael Prokop <mika@debian.org>
-Build-Depends: debhelper (>= 7), libaio-dev
+Build-Depends: debhelper (>= 7), libaio-dev, librdmacm-dev, libibverbs-dev
 Standards-Version: 3.9.2
 Homepage: http://freshmeat.net/projects/fio
 Vcs-Git: git://git.debian.org/git/collab-maint/fio.git

=== debian/rules ===
--- 
+++ 
@@ -21,7 +21,8 @@
 	dh_testdir
 
 	# Add here commands to compile the package.
-	$(MAKE)
+	# Build inclusive I/O engine rdma.
+	EXTFLAGS="-DFIO_HAVE_RDMA" EXTLIBS="-libverbs -lrdmacm" $(MAKE)
 
 	touch $@

## fio 2.0.8

=== Makefile ===
--- 
+++ 
@@ -2,27 +2,27 @@
 DEBUGFLAGS = -D_FORTIFY_SOURCE=2 -DFIO_INC_DEBUG
 CPPFLAGS= -D_GNU_SOURCE -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64 \
 	$(DEBUGFLAGS)
-OPTFLAGS= -O2 -fno-omit-frame-pointer -g $(EXTFLAGS)
+OPTFLAGS= -O3 -fno-omit-frame-pointer -g $(EXTFLAGS)
 CFLAGS	= -std=gnu99 -Wwrite-strings -Wall $(OPTFLAGS)
-LIBS	= -lm
+LIBS	= -lm $(EXTLIBS)
 PROGS	= fio
 SCRIPTS = fio_generate_plots
 UNAME  := $(shell uname)
 
-SOURCE = gettime.c fio.c ioengines.c init.c stat.c log.c time.c filesetup.c \
+SOURCE := gettime.c fio.c ioengines.c init.c stat.c log.c time.c filesetup.c \
 		eta.c verify.c memory.c io_u.c parse.c mutex.c options.c \
 		rbtree.c smalloc.c filehash.c profile.c debug.c lib/rand.c \
-		lib/num2str.c $(wildcard crc/*.c) engines/cpu.c \
+		lib/num2str.c lib/ieee754.c $(wildcard crc/*.c) engines/cpu.c \
 		engines/mmap.c engines/sync.c engines/null.c engines/net.c \
-		memalign.c
+		memalign.c server.c client.c iolog.c backend.c libfio.c flow.c
 
 ifeq ($(UNAME), Linux)
   SOURCE += diskutil.c fifo.c blktrace.c helpers.c cgroup.c trim.c \
 		engines/libaio.c engines/posixaio.c engines/sg.c \
 		engines/splice.c engines/syslet-rw.c engines/guasi.c \
-		engines/binject.c profiles/tiobench.c
+		engines/binject.c engines/rdma.c profiles/tiobench.c
   LIBS += -lpthread -ldl -lrt -laio
-  CFLAGS += -rdynamic
+  LDFLAGS += -rdynamic
 endif
 ifeq ($(UNAME), SunOS)
   SOURCE += fifo.c lib/strsep.c helpers.c engines/posixaio.c \
@@ -33,12 +33,12 @@
 ifeq ($(UNAME), FreeBSD)
   SOURCE += helpers.c engines/posixaio.c
   LIBS	 += -lpthread -lrt
-  CFLAGS += -rdynamic
+  LDFLAGS += -rdynamic
 endif
 ifeq ($(UNAME), NetBSD)
   SOURCE += helpers.c engines/posixaio.c
   LIBS	 += -lpthread -lrt
-  CFLAGS += -rdynamic
+  LDFLAGS += -rdynamic
 endif
 ifeq ($(UNAME), AIX)
   SOURCE += fifo.c helpers.c lib/getopt_long.c engines/posixaio.c
@@ -56,12 +56,25 @@
   LIBS	 += -lpthread -ldl
 endif
 ifneq (,$(findstring CYGWIN,$(UNAME)))
-  SOURCE += engines/windowsaio.c
-  LIBS	 += -lpthread -lrt -lpsapi
-  CFLAGS += -DPSAPI_VERSION=1
+  SOURCE := $(filter-out engines/mmap.c,$(SOURCE))
+  SOURCE += engines/windowsaio.c os/windows/posix.c
+  LIBS	 += -lpthread -lpsapi -lws2_32
+  CFLAGS += -DPSAPI_VERSION=1 -Ios/windows/posix/include -Wno-format
+  CC	  = x86_64-w64-mingw32-gcc
 endif
 
 OBJS = $(SOURCE:.c=.o)
+
+T_SMALLOC_OBJS = t/stest.o
+T_SMALLOC_OBJS += mutex.o smalloc.o t/log.o
+T_SMALLOC_PROGS = t/stest
+
+T_IEEE_OBJS = t/ieee754.o
+T_IEEE_OBJS += ieee754.o
+T_IEEE_PROGS = t/ieee754
+
+T_OBJS = $(T_SMALLOC_OBJS)
+T_OBJS += $(T_IEEE_OBJS)
 
 ifneq ($(findstring $(MAKEFLAGS),s),s)
 ifndef V
@@ -73,12 +86,35 @@
 INSTALL = install
 prefix = /usr/local
 bindir = $(prefix)/bin
+
+ifeq ($(UNAME), Darwin)
+mandir = /usr/share/man
+else
 mandir = $(prefix)/man
+endif
 
-all: .depend $(PROGS) $(SCRIPTS)
+all: .depend $(PROGS) $(SCRIPTS) FORCE
 
-.c.o: .depend
+.PHONY: all install clean
+.PHONY: FORCE cscope
+
+FIO-VERSION-FILE: FORCE
+	@$(SHELL) ./FIO-VERSION-GEN
+-include FIO-VERSION-FILE
+
+CFLAGS += -DFIO_VERSION='"$(FIO_VERSION)"'
+
+.c.o: .depend FORCE
 	$(QUIET_CC)$(CC) -o $@ -c $(CFLAGS) $(CPPFLAGS) $<
+
+init.o: FIO-VERSION-FILE
+	$(QUIET_CC)$(CC) -o init.o -c $(CFLAGS) $(CPPFLAGS) -c init.c
+
+t/stest: $(T_SMALLOC_OBJS)
+	$(QUIET_CC)$(CC) $(LDFLAGS) $(CFLAGS) -o $@ $(T_SMALLOC_OBJS) $(LIBS) $(LDFLAGS)
+
+t/ieee754: $(T_IEEE_OBJS)
+	$(QUIET_CC)$(CC) $(LDFLAGS) $(CFLAGS) -o $@ $(T_IEEE_OBJS) $(LIBS) $(LDFLAGS)
 
 fio: $(OBJS)
 	$(QUIET_CC)$(CC) $(LDFLAGS) $(CFLAGS) -o $@ $(OBJS) $(LIBS) $(LDFLAGS)
@@ -88,13 +124,13 @@
 
 $(PROGS): .depend
 
-clean:
-	-rm -f .depend $(OBJS) $(PROGS) core.* core
+clean: FORCE
+	-rm -f .depend $(OBJS) $(T_OBJS) $(PROGS) $(T_PROGS) core.* core FIO-VERSION-FILE
 
 cscope:
 	@cscope -b -R
 
-install: $(PROGS) $(SCRIPTS)
+install: $(PROGS) $(SCRIPTS) FORCE
 	$(INSTALL) -m 755 -d $(DESTDIR)$(bindir)
 	$(INSTALL) $(PROGS) $(SCRIPTS) $(DESTDIR)$(bindir)
 	$(INSTALL) -m 755 -d $(DESTDIR)$(mandir)/man1

=== debian/changelog ===
fio (2.0.8-2) unstable; urgency=low

  * debian/patches/ftbfs-fix-for-mips-architecture: 
    Fixed build failure on mips and mipsel architectures. Sven Hoexter
    suggested the fix and Jens Axboe confirmed it. Thanks.

 -- Martin Steigerwald <ms@teamix.de>  Wed, 27 Jun 2012 09:25:49 +0200

fio (2.0.8-1) unstable; urgency=low

  [ Ritesh Raj Sarraf ]
  * Fix Vcs-Browser URL.

  [ Martin Steigerwald ]
  * Imported Upstream version 2.0.7 which sports a client / server
    architecture.
  * debian/control: Updated to standards version 3.9.3.
    No changes needed.
  * debian/patches:
    * makefile: Updated for fio 2.0.7 makefile.
    * manpage: Removed, applied upstream.
  * debian/copyright:
    * Updated to 2012.
    * Converted to machine readable format 1.0.
  * Imported Upstream version 2.0.8
  * patches/makefile-hardening and debian/rules: Changed to build
    fio with hardening flags.

 -- Martin Steigerwald <ms@teamix.de>  Tue, 26 Jun 2012 09:28:22 +0200

=== debian/control ===
Source: fio
Section: utils
Priority: optional
Maintainer: Martin Steigerwald <ms@teamix.de>
Uploaders: Michael Prokop <mika@debian.org>
Build-Depends: debhelper (>= 7), dpkg-dev (>= 1.16.1~), libaio-dev, librdmacm-dev, libibverbs-dev
Standards-Version: 3.9.3
Homepage: http://freshmeat.net/projects/fio
Vcs-Git: git://git.debian.org/git/collab-maint/fio.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/fio.git

Package: fio
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: gnuplot
Description: flexible I/O tester
 fio is a tool that will spawn a number of threads or processes doing a
 particular type of I/O action as specified by the user. fio takes a
 number of global parameters, each inherited by the thread unless
 otherwise parameters given to them overriding that setting is given.
 The typical use of fio is to write a job file matching the I/O load
 one wants to simulate.

=== debian/rules ===
--- 
+++ 
@@ -8,6 +8,10 @@
 
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
+
+# For hardening build flags
+DPKG_EXPORT_BUILDFLAGS = 1
+include /usr/share/dpkg/buildflags.mk
 
 build: build-arch build-indep
 
@@ -20,7 +24,6 @@
 build-stamp:
 	dh_testdir
 
-	# Add here commands to compile the package.
 	# Build inclusive I/O engine rdma.
 	EXTFLAGS="-DFIO_HAVE_RDMA" EXTLIBS="-libverbs -lrdmacm" $(MAKE)

## fio 2.1.3

=== Makefile ===
ifneq ($(wildcard config-host.mak),)
all:
include config-host.mak
config-host-mak: configure
	@echo $@ is out-of-date, running configure
	@sed -n "/.*Configured with/s/[^:]*: //p" $@ | sh
else
config-host.mak:
ifneq ($(MAKECMDGOALS),clean)
	@echo "Running configure for you..."
	@./configure
endif
all:
include config-host.mak
endif

DEBUGFLAGS = -D_FORTIFY_SOURCE=2 -DFIO_INC_DEBUG
CPPFLAGS= -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64 $(DEBUGFLAGS)
OPTFLAGS= -O3 -g -ffast-math
CFLAGS	= -std=gnu99 -Wwrite-strings -Wall -Wdeclaration-after-statement $(OPTFLAGS) $(EXTFLAGS) $(BUILD_CFLAGS)
LIBS	+= -lm $(EXTLIBS)
PROGS	= fio
SCRIPTS = tools/fio_generate_plots tools/plot/fio2gnuplot tools/genfio

ifdef CONFIG_GFIO
  PROGS += gfio
endif

SOURCE := gettime.c ioengines.c init.c stat.c log.c time.c filesetup.c \
		eta.c verify.c memory.c io_u.c parse.c mutex.c options.c \
		lib/rbtree.c smalloc.c filehash.c profile.c debug.c lib/rand.c \
		lib/num2str.c lib/ieee754.c $(wildcard crc/*.c) engines/cpu.c \
		engines/mmap.c engines/sync.c engines/null.c engines/net.c \
		memalign.c server.c client.c iolog.c backend.c libfio.c flow.c \
		cconv.c lib/prio_tree.c json.c lib/zipf.c lib/axmap.c \
		lib/lfsr.c gettime-thread.c helpers.c lib/flist_sort.c \
		lib/hweight.c lib/getrusage.c idletime.c td_error.c \
		profiles/tiobench.c profiles/act.c io_u_queue.c

ifdef CONFIG_64BIT_LLP64
  CFLAGS += -DBITS_PER_LONG=32
endif
ifdef CONFIG_64BIT
  CFLAGS += -DBITS_PER_LONG=64
endif
ifdef CONFIG_32BIT
  CFLAGS += -DBITS_PER_LONG=32
endif
ifdef CONFIG_LIBAIO
  SOURCE += engines/libaio.c
endif
ifdef CONFIG_RDMA
  SOURCE += engines/rdma.c
endif
ifdef CONFIG_POSIXAIO
  SOURCE += engines/posixaio.c
endif
ifdef CONFIG_LINUX_FALLOCATE
  SOURCE += engines/falloc.c
endif
ifdef CONFIG_LINUX_EXT4_MOVE_EXTENT
  SOURCE += engines/e4defrag.c
endif
ifdef CONFIG_LINUX_SPLICE
  SOURCE += engines/splice.c
endif
ifdef CONFIG_GUASI
  SOURCE += engines/guasi.c
endif
ifdef CONFIG_FUSION_AW
  SOURCE += engines/fusion-aw.c
endif
ifdef CONFIG_SOLARISAIO
  SOURCE += engines/solarisaio.c
endif
ifdef CONFIG_WINDOWSAIO
  SOURCE += engines/windowsaio.c
endif
ifndef CONFIG_STRSEP
  SOURCE += lib/strsep.c
endif
ifndef CONFIG_STRCASESTR
  SOURCE += lib/strcasestr.c
endif
ifndef CONFIG_GETOPT_LONG_ONLY
  SOURCE += lib/getopt_long.c
endif
ifndef CONFIG_INET_ATON
  SOURCE += lib/inet_aton.c
endif

ifeq ($(CONFIG_TARGET_OS), Linux)
  SOURCE += diskutil.c fifo.c blktrace.c cgroup.c trim.c engines/sg.c \
		engines/binject.c
  LIBS += -lpthread -ldl
  LDFLAGS += -rdynamic
endif
ifeq ($(CONFIG_TARGET_OS), Android)
  SOURCE += diskutil.c fifo.c blktrace.c trim.c profiles/tiobench.c
  LIBS += -ldl
  LDFLAGS += -rdynamic
endif
ifeq ($(CONFIG_TARGET_OS), SunOS)
  LIBS	 += -lpthread -ldl
  CPPFLAGS += -D__EXTENSIONS__
endif
ifeq ($(CONFIG_TARGET_OS), FreeBSD)
  LIBS	 += -lpthread -lrt
  LDFLAGS += -rdynamic
endif
ifeq ($(CONFIG_TARGET_OS), NetBSD)
  LIBS	 += -lpthread -lrt
  LDFLAGS += -rdynamic
endif
ifeq ($(CONFIG_TARGET_OS), AIX)
  LIBS	 += -lpthread -ldl -lrt
  CPPFLAGS += -D_LARGE_FILES -D__ppc__
  LDFLAGS += -L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000
endif
ifeq ($(CONFIG_TARGET_OS), HP-UX)
  LIBS   += -lpthread -ldl -lrt
  CFLAGS += -D_LARGEFILE64_SOURCE -D_XOPEN_SOURCE_EXTENDED
endif
ifeq ($(CONFIG_TARGET_OS), Darwin)
  LIBS	 += -lpthread -ldl
endif
ifneq (,$(findstring CYGWIN,$(CONFIG_TARGET_OS)))
  SOURCE := $(filter-out engines/mmap.c,$(SOURCE))
  SOURCE += os/windows/posix.c
  LIBS	 += -lpthread -lpsapi -lws2_32
  CFLAGS += -DPSAPI_VERSION=1 -Ios/windows/posix/include -Wno-format
endif

OBJS = $(SOURCE:.c=.o)

FIO_OBJS = $(OBJS) fio.o
GFIO_OBJS = $(OBJS) gfio.o graph.o tickmarks.o ghelpers.o goptions.o gerror.o \
			gclient.o gcompat.o cairo_text_helpers.o printing.o

-include $(OBJS:.o=.d)

T_SMALLOC_OBJS = t/stest.o
T_SMALLOC_OBJS += gettime.o mutex.o smalloc.o t/log.o
T_SMALLOC_PROGS = t/stest

T_IEEE_OBJS = t/ieee754.o
T_IEEE_OBJS += lib/ieee754.o
T_IEEE_PROGS = t/ieee754

T_ZIPF_OBS = t/genzipf.o
T_ZIPF_OBJS += t/log.o lib/ieee754.o lib/rand.o lib/zipf.o t/genzipf.o
T_ZIPF_PROGS = t/genzipf

T_AXMAP_OBJS = t/axmap.o
T_AXMAP_OBJS += lib/lfsr.o lib/axmap.o
T_AXMAP_PROGS = t/axmap

T_LFSR_TEST_OBJS = t/lfsr-test.o
T_LFSR_TEST_OBJS += lib/lfsr.o
T_LFSR_TEST_PROGS = t/lfsr-test

T_OBJS = $(T_SMALLOC_OBJS)
T_OBJS += $(T_IEEE_OBJS)
T_OBJS += $(T_ZIPF_OBJS)
T_OBJS += $(T_AXMAP_OBJS)
T_OBJS += $(T_LFSR_TEST_OBJS)

T_PROGS = $(T_SMALLOC_PROGS)
T_PROGS += $(T_IEEE_PROGS)
T_PROGS += $(T_ZIPF_PROGS)
T_PROGS += $(T_AXMAP_PROGS)
T_PROGS += $(T_LFSR_TEST_PROGS)

ifneq ($(findstring $(MAKEFLAGS),s),s)
ifndef V
	QUIET_CC	= @echo '   ' CC $@;
	QUIET_LINK	= @echo '   ' LINK $@;
	QUIET_DEP	= @echo '   ' DEP $@;
endif
endif

ifeq ($(CONFIG_TARGET_OS), SunOS)
	INSTALL = ginstall
else
	INSTALL = install
endif
prefix = /usr/local
bindir = $(prefix)/bin

ifeq ($(CONFIG_TARGET_OS), Darwin)
mandir = /usr/share/man
sharedir = /usr/share/fio
else
mandir = $(prefix)/man
sharedir = $(prefix)/share/fio
endif

all: $(PROGS) $(SCRIPTS) FORCE

.PHONY: all install clean
.PHONY: FORCE cscope

FIO-VERSION-FILE: FORCE
	@$(SHELL) ./FIO-VERSION-GEN
-include FIO-VERSION-FILE

override CFLAGS += -DFIO_VERSION='"$(FIO_VERSION)"'

.c.o: FORCE FIO-VERSION-FILE
	$(QUIET_CC)$(CC) -o $@ $(CFLAGS) $(CPPFLAGS) -c $<
	@$(CC) -MM $(CFLAGS) $(CPPFLAGS) $*.c > $*.d
	@mv -f $*.d $*.d.tmp
	@sed -e 's|.*:|$*.o:|' < $*.d.tmp > $*.d
	@sed -e 's/.*://' -e 's/\\$$//' < $*.d.tmp | fmt -1 | \
		sed -e 's/^ *//' -e 's/$$/:/' >> $*.d
	@rm -f $*.d.tmp

init.o: FIO-VERSION-FILE init.c
	$(QUIET_CC)$(CC) -o init.o $(CFLAGS) $(CPPFLAGS) -c init.c

gcompat.o: gcompat.c gcompat.h
	$(QUIET_CC)$(CC) $(CFLAGS) $(GTK_CFLAGS) $(CPPFLAGS) -c gcompat.c

goptions.o: goptions.c goptions.h
	$(QUIET_CC)$(CC) $(CFLAGS) $(GTK_CFLAGS) $(CPPFLAGS) -c goptions.c

ghelpers.o: ghelpers.c ghelpers.h
	$(QUIET_CC)$(CC) $(CFLAGS) $(GTK_CFLAGS) $(CPPFLAGS) -c ghelpers.c

gerror.o: gerror.c gerror.h
	$(QUIET_CC)$(CC) $(CFLAGS) $(GTK_CFLAGS) $(CPPFLAGS) -c gerror.c

gclient.o: gclient.c gclient.h
	$(QUIET_CC)$(CC) $(CFLAGS) $(GTK_CFLAGS) $(CPPFLAGS) -c gclient.c

gfio.o: gfio.c ghelpers.c
	$(QUIET_CC)$(CC) $(CFLAGS) $(GTK_CFLAGS) $(CPPFLAGS) -c gfio.c

graph.o: graph.c graph.h
	$(QUIET_CC)$(CC) $(CFLAGS) $(GTK_CFLAGS) $(CPPFLAGS) -c graph.c

cairo_text_helpers.o: cairo_text_helpers.c cairo_text_helpers.h
	$(QUIET_CC)$(CC) $(CFLAGS) $(GTK_CFLAGS) $(CPPFLAGS) -c cairo_text_helpers.c

printing.o: printing.c printing.h
	$(QUIET_CC)$(CC) $(CFLAGS) $(GTK_CFLAGS) $(CPPFLAGS) -c printing.c

t/stest: $(T_SMALLOC_OBJS)
	$(QUIET_LINK)$(CC) $(LDFLAGS) $(CFLAGS) -o $@ $(T_SMALLOC_OBJS) $(LIBS)

t/ieee754: $(T_IEEE_OBJS)
	$(QUIET_LINK)$(CC) $(LDFLAGS) $(CFLAGS) -o $@ $(T_IEEE_OBJS) $(LIBS)

fio: $(FIO_OBJS)
	$(QUIET_LINK)$(CC) $(LDFLAGS) $(CFLAGS) -o $@ $(FIO_OBJS) $(LIBS)

gfio: $(GFIO_OBJS)
	$(QUIET_LINK)$(CC) $(LDFLAGS) -o gfio $(GFIO_OBJS) $(LIBS) $(GTK_LDFLAGS)

t/genzipf: $(T_ZIPF_OBJS)
	$(QUIET_LINK)$(CC) $(LDFLAGS) $(CFLAGS) -o $@ $(T_ZIPF_OBJS) $(LIBS)

t/axmap: $(T_AXMAP_OBJS)
	$(QUIET_LINK)$(CC) $(LDFLAGS) $(CFLAGS) -o $@ $(T_AXMAP_OBJS) $(LIBS)

t/lfsr-test: $(T_LFSR_TEST_OBJS)
	$(QUIET_LINK)$(CC) $(LDFLAGS) $(CFLAGS) -o $@ $(T_LFSR_TEST_OBJS) $(LIBS)

clean: FORCE
	-rm -f .depend $(FIO_OBJS) $(GFIO_OBJS) $(OBJS) $(T_OBJS) $(PROGS) $(T_PROGS) core.* core gfio FIO-VERSION-FILE *.d config-host.mak config-host.h

distclean: clean FORCE
	@rm -f cscope.out

cscope:
	@cscope -b -R

tools/plot/fio2gnuplot.1:
	@cat tools/plot/fio2gnuplot.manpage | txt2man -t fio2gnuplot >  tools/plot/fio2gnuplot.1

install: $(PROGS) $(SCRIPTS) tools/plot/fio2gnuplot.1 FORCE
	$(INSTALL) -m 755 -d $(DESTDIR)$(bindir)
	$(INSTALL) $(PROGS) $(SCRIPTS) $(DESTDIR)$(bindir)
	$(INSTALL) -m 755 -d $(DESTDIR)$(mandir)/man1
	$(INSTALL) -m 644 fio.1 $(DESTDIR)$(mandir)/man1
	$(INSTALL) -m 644 tools/fio_generate_plots.1 $(DESTDIR)$(mandir)/man1
	$(INSTALL) -m 644 tools/plot/fio2gnuplot.1 $(DESTDIR)$(mandir)/man1
	$(INSTALL) -m 755 -d $(DESTDIR)$(sharedir)
	$(INSTALL) -m 644 tools/plot/*gpm $(DESTDIR)$(sharedir)/

=== debian/changelog ===
fio (2.1.3-1) unstable; urgency=low

  * Imported Upstream version 2.1.2.
  * debian/patches:
    * makefile:  Refreshed.
    * makefile-hardening: Refreshed.
    * fio_generate_plots-gnuplot: Removed. Applied upstream.
  * debian/control: Add python dependency for tools/fio2gnuplot.py.
  * Add as binary dependency instead. I think dh_python stuff is not required.
  * Imported Upstream version 2.1.3.
  * debian/patches:
    - makefile-hardening: Refreshed.
    - makefile-clean-delete-config-log-and-d-files: Refreshed.
    - manpage-spelling: Removed. Applied upstream.
    - fio2gnuplot-manpage: Added. Fix lintian tag manpage-section-mismatch.
  * debian/source/options:
    - Removed, let default setting decide which compression level to use.

 -- Martin Steigerwald <ms@teamix.de>  Mon, 07 Oct 2013 11:53:41 +0200

fio (2.1.1-1) unstable; urgency=low

  * Imported Upstream version 2.1.1.
  * debian/patches/ftbfs-fix-for-mips-architecture:
    Dropped. Applied upstream.
  * debian/patches/makefile-clean-delete-config-log-and-d-files:
    Delete config.log and *.d files as leaving them behind make
    repeated dpkg-buildpackage builds fail with:
    dpkg-source: info: local changes detected, …
  * debian/patches/manpage-spelling: Fix lintian tag
    spelling-error-in-manpage.
  * debian/control: Added build dependency zlib1g-dev as fio can use
    zlib to compress client/server communication.
  * Switched to xz compression. Saved almost 37 KiB on binary package.
  * Updated to Standards-Version to 3.9.4, no changes needed. 
  * debian/patches/fio_generate_plots-gnuplot:
    Make test for gnuplot work with empty strings (Closes: #700580).
    Thanks to Hervé Werner for providing bug report and fix.

 -- Martin Steigerwald <ms@teamix.de>  Mon, 05 Aug 2013 16:47:21 +0200

=== debian/control ===
Source: fio
Section: utils
Priority: optional
Maintainer: Martin Steigerwald <ms@teamix.de>
Uploaders: Michael Prokop <mika@debian.org>
Build-Depends: debhelper (>= 7), dpkg-dev (>= 1.16.1~), libaio-dev, zlib1g-dev, librdmacm-dev, libibverbs-dev
Standards-Version: 3.9.4
Homepage: http://freshmeat.net/projects/fio
Vcs-Git: git://anonscm.debian.org/collab-maint/fio.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/fio.git

Package: fio
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python
Suggests: gnuplot
Description: flexible I/O tester
 fio is a tool that will spawn a number of threads or processes doing a
 particular type of I/O action as specified by the user. fio takes a
 number of global parameters, each inherited by the thread unless
 otherwise parameters given to them overriding that setting is given.
 The typical use of fio is to write a job file matching the I/O load
 one wants to simulate.

=== debian/rules ===
--- 
+++ 
@@ -74,7 +74,7 @@
 	dh_shlibdeps -a
 	dh_gencontrol -a
 	dh_md5sums -a
-	dh_builddeb -a
+	dh_builddeb -a -- -Zxz
 
 binary: binary-indep binary-arch
 .PHONY: build clean binary-indep binary-arch binary install

## fio 2.1.6.1

=== Makefile ===
--- 
+++ 
@@ -76,6 +76,9 @@
 ifdef CONFIG_WINDOWSAIO
   SOURCE += engines/windowsaio.c
 endif
+ifdef CONFIG_RBD
+  SOURCE += engines/rbd.c
+endif
 ifndef CONFIG_STRSEP
   SOURCE += lib/strsep.c
 endif
@@ -108,6 +111,10 @@
   LIBS	 += -lpthread -lrt
   LDFLAGS += -rdynamic
 endif
+ifeq ($(CONFIG_TARGET_OS), OpenBSD)
+  LIBS	 += -lpthread
+  LDFLAGS += -rdynamic
+endif
 ifeq ($(CONFIG_TARGET_OS), NetBSD)
   LIBS	 += -lpthread -lrt
   LDFLAGS += -rdynamic
@@ -128,7 +135,7 @@
   SOURCE := $(filter-out engines/mmap.c,$(SOURCE))
   SOURCE += os/windows/posix.c
   LIBS	 += -lpthread -lpsapi -lws2_32
-  CFLAGS += -DPSAPI_VERSION=1 -Ios/windows/posix/include -Wno-format
+  CFLAGS += -DPSAPI_VERSION=1 -Ios/windows/posix/include -Wno-format -static
 endif
 
 OBJS = $(SOURCE:.c=.o)

=== debian/changelog ===
fio (2.1.6.1-1) stable; urgency=low

  * New upstream.

 -- Wessel Dankers <wsl@fruit.je>  Mon, 24 Mar 2014 13:41:33 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Martin Steigerwald <ms@teamix.de>
 Uploaders: Michael Prokop <mika@debian.org>
-Build-Depends: debhelper (>= 7), dpkg-dev (>= 1.16.1~), libaio-dev, zlib1g-dev, librdmacm-dev, libibverbs-dev
+Build-Depends: debhelper (>= 7), dpkg-dev (>= 1.16.1~), libaio-dev, zlib1g-dev, librdmacm-dev, libibverbs-dev, librbd-dev
 Standards-Version: 3.9.4
 Homepage: http://freshmeat.net/projects/fio
 Vcs-Git: git://anonscm.debian.org/collab-maint/fio.git

## fio 2.1.11

=== Makefile ===
--- 
+++ 
@@ -15,7 +15,7 @@
 endif
 
 DEBUGFLAGS = -D_FORTIFY_SOURCE=2 -DFIO_INC_DEBUG
-CPPFLAGS= -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64 $(DEBUGFLAGS)
+CPPFLAGS= -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64 -DFIO_INTERNAL $(DEBUGFLAGS)
 OPTFLAGS= -O3 -g -ffast-math
 CFLAGS	= -std=gnu99 -Wwrite-strings -Wall -Wdeclaration-after-statement $(OPTFLAGS) $(EXTFLAGS) $(BUILD_CFLAGS)
 LIBS	+= -lm $(EXTLIBS)
@@ -35,7 +35,8 @@
 		cconv.c lib/prio_tree.c json.c lib/zipf.c lib/axmap.c \
 		lib/lfsr.c gettime-thread.c helpers.c lib/flist_sort.c \
 		lib/hweight.c lib/getrusage.c idletime.c td_error.c \
-		profiles/tiobench.c profiles/act.c io_u_queue.c
+		profiles/tiobench.c profiles/act.c io_u_queue.c filelock.c \
+		lib/tp.c
 
 ifdef CONFIG_64BIT_LLP64
   CFLAGS += -DBITS_PER_LONG=32
@@ -90,6 +91,14 @@
 endif
 ifndef CONFIG_INET_ATON
   SOURCE += lib/inet_aton.c
+endif
+ifdef CONFIG_GFAPI
+  SOURCE += engines/glusterfs.c
+  SOURCE += engines/glusterfs_sync.c
+  SOURCE += engines/glusterfs_async.c
+  ifdef CONFIG_GF_FADVISE
+    CFLAGS += "-DGFAPI_USE_FADVISE"
+  endif
 endif
 
 ifeq ($(CONFIG_TARGET_OS), Linux)
@@ -213,7 +222,7 @@
 
 override CFLAGS += -DFIO_VERSION='"$(FIO_VERSION)"'
 
-.c.o: FORCE FIO-VERSION-FILE
+%.o : %.c
 	$(QUIET_CC)$(CC) -o $@ $(CFLAGS) $(CPPFLAGS) -c $<
 	@$(CC) -MM $(CFLAGS) $(CPPFLAGS) $*.c > $*.d
 	@mv -f $*.d $*.d.tmp
@@ -274,16 +283,21 @@
 	$(QUIET_LINK)$(CC) $(LDFLAGS) $(CFLAGS) -o $@ $(T_LFSR_TEST_OBJS) $(LIBS)
 
 clean: FORCE
-	-rm -f .depend $(FIO_OBJS) $(GFIO_OBJS) $(OBJS) $(T_OBJS) $(PROGS) $(T_PROGS) core.* core gfio FIO-VERSION-FILE *.d config-host.mak config-host.h
+	-rm -f .depend $(FIO_OBJS) $(GFIO_OBJS) $(OBJS) $(T_OBJS) $(PROGS) $(T_PROGS) core.* core gfio FIO-VERSION-FILE *.d lib/*.d crc/*.d engines/*.d profiles/*.d t/*.d config-host.mak config-host.h
 
 distclean: clean FORCE
-	@rm -f cscope.out
+	@rm -f cscope.out fio.pdf fio_generate_plots.pdf fio2gnuplot.pdf
 
 cscope:
 	@cscope -b -R
 
 tools/plot/fio2gnuplot.1:
 	@cat tools/plot/fio2gnuplot.manpage | txt2man -t fio2gnuplot >  tools/plot/fio2gnuplot.1
+
+doc: tools/plot/fio2gnuplot.1
+	@man -t ./fio.1 | ps2pdf - fio.pdf
+	@man -t tools/fio_generate_plots.1 | ps2pdf - fio_generate_plots.pdf
+	@man -t tools/plot/fio2gnuplot.1 | ps2pdf - fio2gnuplot.pdf
 
 install: $(PROGS) $(SCRIPTS) tools/plot/fio2gnuplot.1 FORCE
 	$(INSTALL) -m 755 -d $(DESTDIR)$(bindir)

=== debian/changelog ===
fio (2.1.11-2) unstable; urgency=medium

  * debian/control: Added RBD support by adding librbd-dev to build
    dependencies. Thanks to Benjamin Drung for report and patch.
    Closes: #760266.

 -- Martin Steigerwald <ms@teamix.de>  Tue, 02 Sep 2014 15:37:28 +0200

fio (2.1.11-1) unstable; urgency=medium

  * dh_builddeb without -z9, so use xz, but do not set default level.
  * Imported Upstream version 2.1.11.
  * debian/patches:
    - makefile-hardening: Adapted to new C++ build option.
    - makefile-clean-delete-config-log-and-d-files: Deleted. Fixed upstream.
    - makefile-rm-configlog: Added.
  * debian/control: Updated to standards version 3.9.5.
    No changes needed.

 -- Martin Steigerwald <ms@teamix.de>  Mon, 21 Jul 2014 15:53:36 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Martin Steigerwald <ms@teamix.de>
 Uploaders: Michael Prokop <mika@debian.org>
 Build-Depends: debhelper (>= 7), dpkg-dev (>= 1.16.1~), libaio-dev, zlib1g-dev, librdmacm-dev, libibverbs-dev, librbd-dev
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Homepage: http://freshmeat.net/projects/fio
 Vcs-Git: git://anonscm.debian.org/collab-maint/fio.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/fio.git
